#include <windows.h>

#ifndef _DEBUG 
#pragma comment(linker, "/nodefaultlib:LIBC.lib")
#pragma comment(linker, "/defaultlib:MSVCRT.LIB")
#pragma comment(linker, "/OPT:NOWIN98")
/*
#pragma comment(linker, "/FILEALIGN:0x200")

#pragma comment(linker,"/merge:.rdata=.data")
#pragma comment(linker,"/merge:.text=.data")
#pragma comment(linker,"/merge:.reloc=.data")
#pragma comment(linker,"/ignore:4078")
*/
#endif

//Hooking Code
#pragma pack(push,1)
struct SHookThunk{
	BYTE jmp;
	DWORD addr;
	BYTE  ret;
};
#pragma pack(pop)

VOID HookThunkInit(SHookThunk & ht,DWORD dwAddr);
BOOL HookAPIFunction(LPCSTR lpModuleName,LPCSTR lpFunctionName,LPCVOID lpNewFunction,SHookThunk & htOldFunctionCode);
BOOL UnhookAPIFunction(LPCSTR lpModuleName,LPCSTR lpFunctionName, SHookThunk & htOldFunctionCode);


BOOL HookAPIFunction(LPCSTR lpModuleName,LPCSTR lpFunctionName,LPCVOID lpNewFunction,SHookThunk & htOldFunctionCode)
{
	//Get the library handle if loaded into this process.
	HANDLE  hLib= GetModuleHandle(lpModuleName);
	if(!hLib)
		return FALSE;
	//Get the function address if exported from module.
	DWORD dwAddr =  (DWORD)GetProcAddress((HMODULE)hLib,lpFunctionName);
	if(!dwAddr)
		return FALSE;

	SHookThunk ht;
	HookThunkInit(ht,((DWORD)lpNewFunction - dwAddr - 5));

	//Backup old code
	if(!ReadProcessMemory(GetCurrentProcess(), (LPVOID)dwAddr, &htOldFunctionCode, sizeof(SHookThunk), NULL))
		return FALSE;
	//Write  new code
	if(WriteProcessMemory(GetCurrentProcess(), (LPVOID)dwAddr, &ht, sizeof(SHookThunk), NULL))
		return TRUE;
	return FALSE;;
}
BOOL UnhookAPIFunction(LPCSTR lpModuleName,LPCSTR lpFunctionName, SHookThunk & htOldFunctionCode)
{
	//Get the library handle if loaded into this process.
	HANDLE  hLib= GetModuleHandle(lpModuleName);
	if(!hLib)
		return FALSE;
	//Get the function address if exported from module.
	DWORD dwAddr =  (DWORD)GetProcAddress((HMODULE)hLib,lpFunctionName);
	if(!dwAddr)
		return FALSE;
	
	// Restore original code of function.
	if (WriteProcessMemory(GetCurrentProcess(), (LPVOID)dwAddr, &htOldFunctionCode,sizeof(SHookThunk), NULL))
		return TRUE;
	return FALSE;
}
VOID HookThunkInit(SHookThunk & ht,DWORD dwAddr)
{
	ht.jmp = 0xe9;
	ht.addr = dwAddr;
	ht.ret = 0xc3;
}


//Demo Code


SHookThunk g_msgbox;

int WINAPI MsgBox(HWND hWnd, LPCSTR lpText, LPCSTR lpCaption, UINT uType)
{
	UnhookAPIFunction("user32.dll", "MessageBoxA", g_msgbox);

	int res = MessageBox(hWnd, lpText, "HOOKED", uType);

	HookAPIFunction("User32.dll","MessageBoxA",MsgBox,g_msgbox);

	return res;
}

int APIENTRY  WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	MessageBox(NULL,"Hook test for user32.dll.","Caption",MB_OK);
	HookAPIFunction("User32.dll","MessageBoxA",MsgBox,g_msgbox);//Hooking
	MessageBox(NULL,"Hook test for user32.dll.","Caption",MB_OK);//Testing
	return 0;
}